############################
### UrlGet.tcl		 ###
### Version 1.4		 ###
### By Wcc		 ###
### wcc@techmonkeys.org  ###
### http://dawg.dynu.com ###
### EFnet #|DAWG|Tcl     ###
############################

############################################################################
### Copyright  2000 - 2001 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

##################################################################################
## This script uses Google to return the most relevant url for the series of	##
## keywords you enter. Thanks to aNa|0Gue for the idea.				##
##################################################################################

##############
## COMMANDS ##
##################################################
## DCC ## .urlget <keywords> (Can be changed)	##
######### Returns the most relevant url for the ##
######### keywords you enter.			##
######### ------------------------------------- ##
## PUB ## !urlget <keywords> (Can be changed)	##
######### Returns the most relevant url for the ##
######### keywords you enter.			##
##################################################

#############################################################
## Just load the script, set the variables, and rehash.    ##
#############################################################

#################################################
# Set the pub command for retrieving a url here. #
#################################################

set urlget_setting(cmd_pub) "!urlget"

##################################################
# Set the dcc command for retrieving a url here. #
##################################################

set urlget_setting(cmd_dcc) "urlget"

####################################################
# Set the flag required for retrieving a url here. #
####################################################

set urlget_setting(flag) "-|-"

###################################
# Enable use of bold in DCC chat? #
###################################

set urlget_setting(bold) 1

##########################################
# Prefix "URLGET:" in DCC chat messages? #
##########################################

set urlget_setting(URLGET:) 1

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} {
	putlog "\002URLGET:\002 \002CRITICAL ERROR\002 UrlGet.tcl requires eggdrop 1.6.x to run."
	die "\002URLGET:\002 \002CRITICAL ERROR\002 UrlGet.tcl requires eggdrop 1.6.x to run."
}
if {[info tclversion] < 8.2} {
	putlog "\002URLGET:\002 \002CRITICAL ERROR\002 UrlGet.tcl requires TCL 8.2 or above to run."
	die "\002URLGET:\002 \002CRITICAL ERROR\002 UrlGet.tcl requires TCL 8.2 or above to run."
}
package require http
bind dcc $urlget_setting(flag) $urlget_setting(cmd_dcc) urlget_urlget_dcc
bind pub $urlget_setting(flag) $urlget_setting(cmd_pub) urlget_urlget_pub

proc urlget_dopre {} {
	global urlget_setting
	if {!$urlget_setting(URLGET:)} {
		return ""
	} elseif {!$urlget_setting(bold)} {
		return "URLGET: "
	} else {
		return "\002URLGET:\002 "
	}
}
proc urlget_urlget_pub {nick uhost hand chan text} {
	global urlget_setting
	if {$text == ""} {
		putserv "PRIVMSG $chan :Usage: $urlget_setting(cmd_pub) <keywords>"
	} else {
		regsub -all -- " " "$text" "+" text
		set surl "http://www.google.com/search?btnI=&q=$text"
		set stok [http::geturl $surl]
		upvar $stok sdata
		foreach {i d} $sdata(meta) {
			if {[string match -nocase location $i]} {
				putserv "PRIVMSG $chan :$d"
			}
		}
	}
}
proc urlget_urlget_dcc {hand idx text} {
	global urlget_setting
	if {$text == ""} {
		putdcc $idx "[urlget_dopre]Usage: .$urlget_setting(cmd_dcc) <keywords>"
	} else {
		regsub -all -- " " "$text" "+" text
		set surl "http://www.google.com/search?btnI=&q=$text"
		set stok [http::geturl $surl]
		upvar $stok sdata
		foreach {i d} $sdata(meta) {
			if {[string match -nocase location $i]} {
				putdcc $idx "[urlget_dopre]$d"
			}
		}
	}
}
putlog "\002URLGET:\002 UrlGet.tcl Version 1.4 by Wcc is loaded."